Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.instruct
Class WithParam

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.instruct.Instruction
              net.sf.saxon.instruct.GeneralVariable
                  net.sf.saxon.instruct.WithParam

All Implemented Interfaces:
  Serializable, SourceLocator, Binding, Container, EvaluableItem, SequenceIterable, TailCallReturner, InstructionInfoProvider

    public class WithParam

extends GeneralVariable

An instruction derived from a xsl:with-param element in the stylesheet.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`WithParam()`

Method Summary
`ValueRepresentation` | `evaluateVariable(XPathContext context)` Evaluate the variable (method exists only to satisfy the interface)
`int` | `getInstructionNameCode()` Get the namecode of the instruction for use in diagnostics
`static void` | `getXPathExpressions(WithParam[] params, List list)` Get the XPath expressions used in an array of WithParam parameters (add them to the supplied list)
`static void` | `optimize(Optimizer opt, WithParam[] params, StaticContext env, ItemType contextItemType)`
`TailCall` | `processLeavingTail(XPathContext context)` ProcessLeavingTail: called to do the real work of this instruction.
`static void` | `promoteParams(WithParam[] params, PromotionOffer offer)` Promote the expressions in a set of with-param elements.
`static boolean` | `replaceXPathExpression(WithParam[] params, Expression original, Expression replacement)` Replace a subexpression
`static void` | `simplify(WithParam[] params, StaticContext env)`
`static void` | `typeCheck(WithParam[] params, StaticContext env, ItemType contextItemType)`

Methods inherited from class net.sf.saxon.instruct.GeneralVariable
`display, evaluateItem, getCardinality, getItemType, getLocalSlotNumber, getNameCode, getRequiredType, getSelectExpression, getSelectValue, getSlotNumber, getVariableFingerprint, getVariableName, init, isAssignable, isGlobal, isImplicitlyRequiredParam, isRequiredParam, isTunnelParam, iterate, iterateSubExpressions, optimize, replaceSubExpression, setAssignable, setImplicitlyRequiredParam, setNameCode, setReferenceCount, setRequiredParam, setRequiredType, setSelectExpression, setSlotNumber, setTunnel, setVariableName, simplify, typeCheck`

Methods inherited from class net.sf.saxon.instruct.Instruction
`appendItem, computeCardinality, computeSpecialProperties, createsNewNodes, evaluateAsString, getImplementationMethod, getInstructionInfo, getSourceLocator, isXSLT, process, promote`

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, effectiveBooleanValue, getColumnNumber, getContainingProcedure, getDependencies, getExecutable, getHostLanguage, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, markTailFunctionCalls, resetStaticProperties, setLocationId, setParentExpression, setParentExpression, suppressValidation`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId, getSystemId`

Constructor Detail

### WithParam

    public WithParam()

Method Detail

### getInstructionNameCode

    public int getInstructionNameCode()

  Description copied from class: `Instruction`
  Get the namecode of the instruction for use in diagnostics

  Overrides:
    `getInstructionNameCode` in class `GeneralVariable`

### processLeavingTail

    public TailCall processLeavingTail(XPathContext context)
                                throws XPathException

  Description copied from class: `Instruction`
  ProcessLeavingTail: called to do the real work of this instruction. This method must be implemented in each subclass. The results of the instruction are written to the current Receiver, which can be obtained via the Controller.

  Specified by:
    `processLeavingTail` in interface `TailCallReturner`
  Specified by:
    `processLeavingTail` in class `Instruction`
  Parameters:
    `context` - The dynamic context of the transformation, giving access to the current node, the current variables, etc.
  Returns:
    null if the instruction has completed execution; or a TailCall indicating a function call or template call that is delegated to the caller, to be made after the stack has been unwound so as to save stack space.
  Throws:
    `XPathException`

### simplify

    public static void simplify(WithParam[] params,
                                StaticContext env)
                         throws XPathException

  Throws:
    `XPathException`

### typeCheck

    public static void typeCheck(WithParam[] params,
                                 StaticContext env,
                                 ItemType contextItemType)
                          throws XPathException

  Throws:
    `XPathException`

### optimize

    public static void optimize(Optimizer opt,
                                WithParam[] params,
                                StaticContext env,
                                ItemType contextItemType)
                         throws XPathException

  Throws:
    `XPathException`

### promoteParams

    public static void promoteParams(WithParam[] params,
                                     PromotionOffer offer)
                              throws XPathException

  Promote the expressions in a set of with-param elements. This is a convenience method for use by subclasses.

  Throws:
    `XPathException`

### getXPathExpressions

    public static void getXPathExpressions(WithParam[] params,
                                           List list)

  Get the XPath expressions used in an array of WithParam parameters (add them to the supplied list)

### replaceXPathExpression

    public static boolean replaceXPathExpression(WithParam[] params,
                                                 Expression original,
                                                 Expression replacement)

  Replace a subexpression

### evaluateVariable

    public ValueRepresentation evaluateVariable(XPathContext context)
                                         throws XPathException

  Evaluate the variable (method exists only to satisfy the interface)

  Throws:
    `XPathException`

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.